; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive 
  
;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\dialogs.inc
      include \masm32\macros\macros.asm

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

      DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD 

    ; ---------------
    ; status bar text
    ; ---------------
      SBtext MACRO part,lpString
        invoke SendMessage,hStatus,SB_SETTEXT,part-1,reparg(lpString)
      ENDM

    ; --------------
    ; title bar text
    ; --------------
      TBtext MACRO lpString
        invoke SetWindowText,FUNC(GetActiveWindow),reparg(lpString)
      ENDM

    ; -----------------
    ; edit control text
    ; -----------------
      EDtext MACRO lpString
        invoke SetWindowText,hEdit,reparg(lpString)
      ENDM

    ; ---------------------------
    ; append text to edit control
    ; ---------------------------
      EDappend MACRO lpstring
        invoke SetFocus,hEdit
        invoke SendMessage,hEdit,WM_KEYDOWN,VK_END,0
        invoke SendMessage,hEdit,EM_REPLACESEL,TRUE,reparg(lpstring)
        invoke SendMessage,hEdit,EM_REPLACESEL,TRUE,chr$(13,10)
      ENDM

    ; --------------------------------------
    ; copy edit control content to clipboard
    ; --------------------------------------
      EDcopy MACRO
        invoke SetFocus,hEdit
        invoke SendMessage,hEdit,EM_SETSEL,0,rv(GetWindowTextLength,hEdit)
        invoke SendMessage,hEdit,WM_COPY,0,0
      ENDM

      EDclear equ <EDtext 0>

    .data?
        hWnd      dd ?
        hInstance dd ?
        hStatus   dd ?
        hEdit     dd ?

    .code

; 

start: 
      mov hInstance, FUNC(GetModuleHandle,NULL)
    call main
    invoke ExitProcess,eax

; 

main proc

    invoke InitCommonControls

    Dialog "   ", \                         ; caption
           "MS Sans Serif",10, \            ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            15, \                           ; number of controls
            50,50,300,185, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgButton "Test 1",WS_TABSTOP,5, 5,70,13,101
    DlgButton "Test 2",WS_TABSTOP,5,20,70,13,102
    DlgButton "Test 3",WS_TABSTOP,5,35,70,13,103
    DlgButton "Test 4",WS_TABSTOP,5,50,70,13,104
    DlgButton "Test 5",WS_TABSTOP,5,65,70,13,105
    DlgButton "Test 6",WS_TABSTOP,5,80,70,13,106
    DlgButton "Test 7",WS_TABSTOP,5,95,70,13,107
    DlgButton "Test 8",WS_TABSTOP,5,110,70,13,108
    DlgButton "Test 9",WS_TABSTOP,5,125,70,13,109
    DlgButton "Test 10",WS_TABSTOP,5,140,70,13,110

    DlgButton "Reset",WS_TABSTOP,80,140,50,13,120
    DlgButton "Copy",WS_TABSTOP,162,140,50,13,121
    DlgButton "Close",WS_TABSTOP,243,140,50,13,IDCANCEL


    DlgStatus 130
    DlgEdit WS_TABSTOP or ES_MULTILINE or ES_WANTRETURN or \
            ES_LEFT or WS_BORDER or WS_VSCROLL,80,5,213,132,111

    CallModalDialog hInstance,0,DlgProc,NULL

    ret

main endp

; 

align 4

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 
  
    LOCAL hDC   :DWORD 
      LOCAL ps    :PAINTSTRUCT 
      LOCAL rct   :RECT 
      LOCAL crct  :RECT 
      LOCAL buffer1[260]:BYTE 
      LOCAL buffer2[260]:BYTE 
      LOCAL buffer3[260]:BYTE 
      LOCAL buffer4[260]:BYTE 
  
    STRING MainTitle,"Large Algorith Test Bed"

    switch uMsg
      case WM_INITDIALOG
        m2m hWnd, hWin
        invoke SendMessage,hWnd,WM_SETICON,1,
                           FUNC(LoadIcon,NULL,IDI_ASTERISK)
        invoke SetWindowText,hWnd,ADDR MainTitle

        mov hStatus, FUNC(GetDlgItem,hWnd,130)
        GLOBAL sbarray dd 50,100,150,200,250,300,350,400,450,-1

        invoke SendMessage,hStatus,SB_SETPARTS,10,ADDR sbarray
        mov hEdit,   FUNC(GetDlgItem,hWnd,111)
        invoke SendMessage,hEdit,WM_SETFONT,
                           FUNC(GetStockObject,ANSI_FIXED_FONT),TRUE
        mov eax, 1

      case WM_COMMAND
        switch wParam
          case 101
            TBtext "ID 101"
            SBtext 1,"tst 1"
            EDtext "You pressed button 1"

          case 102
            TBtext "ID 102"
            SBtext 2,"tst 2"
            EDtext "You pressed button 2"

          case 103
            TBtext "ID 103"
            SBtext 3,"tst 3"
            EDtext "You pressed button 3"

          case 104
            TBtext "ID 104"
            SBtext 4,"tst 4"
            EDtext "You pressed button 4"

          case 105
            TBtext "ID 105"
            SBtext 5,"tst 5"
            EDtext "You pressed button 5"

          case 106
            TBtext "ID 106"
            SBtext 6,"tst 6"
            EDtext "You pressed button 6"

          case 107
            TBtext "ID 107"
            SBtext 7,"tst 7"
            EDtext "You pressed button 7"

          case 108
            TBtext "ID 108"
            SBtext 8,"tst 8"
            EDtext "You pressed button 8"

          case 109
            TBtext "ID 109"
            SBtext 9,"tst 9"
            EDtext "You pressed button 9"

          case 110
            TBtext "ID 110"
            SBtext 10,"tst 10"
            EDtext "You pressed button 10"

          case 120
            EDclear
            SBtext 1,0
            SBtext 2,0
            SBtext 3,0
            SBtext 4,0
            SBtext 5,0
            SBtext 6,0
            SBtext 7,0
            SBtext 8,0
            SBtext 9,0
            SBtext 10,0
            TBtext ADDR MainTitle

          case 121
            EDcopy

          case IDCANCEL
            jmp quit_dialog
        endsw

      case WM_PAINT
        mov hDC, FUNC(BeginPaint,hWin,ADDR ps)
        invoke GetClientRect,hWin,ADDR rct
        invoke GetWindowRect,hStatus,ADDR crct
        mov eax, crct.bottom
        sub eax, crct.top
        sub rct.bottom, eax
        invoke DrawEdge,hDC,ADDR rct,EDGE_ETCHED,BF_RECT
        invoke EndPaint,hWin,ADDR ps

      case WM_CLOSE
        quit_dialog: 
          invoke EndDialog,hWin,0
    endsw

    xor eax, eax
    ret

DlgProc endp

; 

end start
